/****************************************************************************
**
** This file is part of PLCEdit, an open-source cross-platform editor 
** for PLC source files (e.g. from Moeller, CoDeSys and Siemens).
** Copyright (C) 2005-2009  M. Rehfeldt
**
** This software uses classes of Trolltech Qt toolkit and is freeware. 
** This file may be used under the terms of the GNU General Public License 
** version 2.0 or (at your option) any later version as published by the 
** Free Software Foundation and appearing in the file LICENSE.GPL included 
** in the packaging of this file. 
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Contact e-mail: M. Rehfeldt <info@plcedit.org>
** Program URL   : http://www.plcedit.org
**
****************************************************************************/


#include <QtGui>

#include "fncdialog.h"

FncDialog::FncDialog(QWidget *parent)
    : QDialog(parent) 
{ //! creating function
	
  setupUi(this);
  retranslateUi();
   
  connect(Fnc_treeWidget, SIGNAL(itemSelectionChanged()), this, SLOT(setokButtonState()));
  connect(Fnc_okButton, SIGNAL(clicked()), this, SLOT(okButtonState())); 
}


FncDialog::~FncDialog()
{ //! virtual destructor
}


void FncDialog::setokButtonState()
{ //! set ok Button by detecting the selected items

  if (Fnc_treeWidget->indexOfTopLevelItem(Fnc_treeWidget->currentItem()) == -1)  
    Fnc_okButton->setEnabled(true);
  else
    Fnc_okButton->setDisabled(true);
}


void FncDialog::okButtonState()
{ //! return okButton state

  if (Fnc_okButton->isEnabled())
  { emit accept(); close(); }
}


QString FncDialog::currentName()
{ //! get actual tree item with ": " add on as function type string

  return((": " + this->Fnc_treeWidget->currentItem()->text(0)));
}


void FncDialog::retranslateUi()
{ //! retranslate Ui

  this->setWindowTitle(tr("Function Type Selection")); 
  
  //ok Button
  Fnc_okButton->setText(tr("Ok"));
  Fnc_okButton->setStatusTip(tr("Accept selection and close window"));
  Fnc_okButton->setToolTip(Fnc_okButton->statusTip());
  
  //cancel Button
  Fnc_cancelButton->setText(tr("Cancel"));
  Fnc_cancelButton->setStatusTip(tr("Cancel selection and close window"));
  Fnc_cancelButton->setToolTip(Fnc_cancelButton->statusTip());
 
}
